// Queue of events reported to debugger by window-event-handler and debug-event-handler threads.
// 11 Mar 1996 Derek Lieber
//
package jd;
import  java.util.Vector;
import  util.Tracer;

class DebuggerEventQueue
   {
   Vector queue;
   
   DebuggerEventQueue()
      {
      this.queue = new Vector();
      }

   synchronized
   void
   put(DebuggerEvent e)
      {
   // Tracer.trace("enqueue", e);
      queue.addElement(e);
      notify();
      }
   
   synchronized
   DebuggerEvent
   get()
      throws InterruptedException
      {
      if (queue.size() == 0)
         {
      // Tracer.trace("wait");
         wait();
         }
      DebuggerEvent e = (DebuggerEvent)queue.elementAt(0);
      queue.removeElementAt(0);
   // Tracer.trace("dequeue", e);
      return e;
      }
   }
