// Layout constraints for arranging window components.
// 07 Feb 1996 Derek Lieber
//
package ui;
import  java.awt.*;

// A cell whose contents cannot expand.
// See also: StandardConstraints, ExpandableWidthConstraints
//
public class FixedWidthConstraints extends GridBagConstraints
   {
   public
   FixedWidthConstraints(boolean lastCellOnRow)
      {
      fill       = NONE;
      weightx    = 0.0;
      weighty    = 0.0;
      gridheight = 1;
      gridwidth  = lastCellOnRow ? REMAINDER : 1;
      }
   }
